from AC3main import AC3LipSync
from AC3utils import dec2hex, hex2dec
from Components.ActionMap import ActionMap, NumberActionMap
from Components.Button import Button
from Components.ConfigList import ConfigListScreen
from Components.Label import Label,MultiColorLabel
from Components.ProgressBar import ProgressBar
from Components.config import config, ConfigSubsection, ConfigSubList, ConfigInteger, ConfigFloat, getConfigListEntry
from Screens.ChoiceBox import ChoiceBox
from Screens.MessageBox import MessageBox
from Screens.Screen import Screen
from __init__ import _
import os

config.AC3LipSync = ConfigSubsection()
config.AC3LipSync.lowerBound = ConfigInteger(default = 0, limits = (0,10000))
config.AC3LipSync.upperBound = ConfigInteger(default = 405, limits = (0,10000))
config.AC3LipSync.arrowStepSize = ConfigInteger(default = 45, limits = (0,10000))
config.AC3LipSync.stepSize = ConfigInteger(default = 5, limits = (0,10000))

class AC3LipSyncSetup(ConfigListScreen, Screen):
    skin = """
    <screen position="75,90" size="560,400" title="AC3 Lip Sync Setup">
      <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/AC3LipSync/img/key-red.png" position="0,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
      <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/AC3LipSync/img/key-green.png" position="140,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
      <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/AC3LipSync/img/key-yellow.png" position="280,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
      <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/AC3LipSync/img/key-blue.png" position="420,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
      <widget name="key_red" position="0,0" zPosition="1" size="140,40"
        font="Regular;20" valign="center" halign="center" backgroundColor="#9f1313" transparent="1"
        shadowColor="#000000" shadowOffset="-1,-1" />
      <widget name="key_green" position="140,0" zPosition="1" size="140,40"
        font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1"
        shadowColor="#000000" shadowOffset="-1,-1" />
      <widget name="key_yellow" position="280,0" zPosition="1" size="140,40"
        font="Regular;20" valign="center" halign="center" backgroundColor="#a08500" transparent="1"
        shadowColor="#000000" shadowOffset="-1,-1" />
      <widget name="key_blue" position="420,0" zPosition="1" size="140,40"
        font="Regular;20" valign="center" halign="center" backgroundColor="#18188b" transparent="1"
        shadowColor="#000000" shadowOffset="-1,-1" />
      <widget name="config" position="10,40" size="540,320" scrollbarMode="showOnDemand" />
    </screen>"""

    def __init__(self, session, args = None):
        Screen.__init__(self, session)
                
        # nun erzeugen wir eine liste von elementen fuer die menu liste.
        self.list = [ ]
        self.list.append(getConfigListEntry(_("Minimum delay"), config.AC3LipSync.lowerBound))
        self.list.append(getConfigListEntry(_("Maximum delay"), config.AC3LipSync.upperBound))
        self.list.append(getConfigListEntry(_("Step in ms for arrow keys"), config.AC3LipSync.arrowStepSize))
        ConfigListScreen.__init__(self, self.list)

        # DO NOT ASK.
        self["key_red"] = Button(_("Cancel"))
        self["key_green"] = Button(_("Save"))
        self["key_yellow"] = Button(_("Set delay"))
        self["key_blue"] = Button(_(" "))        

        self["setupActions"] = NumberActionMap(["SetupActions", "ColorActions"],
        {
            "save": self.save,
            "cancel": self.cancel,
            "green": self.save,
            "red": self.cancel,
            "ok": self.save,
        }, -2)
            
    def save(self):
        for x in self["config"].list:
            x[1].save()
        iLowerBound = int(config.AC3LipSync.lowerBound.getValue())
        iUpperBound = int(config.AC3LipSync.upperBound.getValue())
        iStepSize = (iUpperBound - iLowerBound)/9
        config.AC3LipSync.stepSize.setValue(iStepSize)
        config.AC3LipSync.stepSize.save()
        iUpperBound = iLowerBound + (iStepSize*9)
        config.AC3LipSync.upperBound.setValue(iUpperBound)
        config.AC3LipSync.upperBound.save()
        self.close()

    def cancel(self):
        for x in self["config"].list:
            x[1].cancel()
        self.close()

    def startPlugin(self):
        self.save
        AC3LipSync(self.session)
        self.close()